<?php

namespace App\Models;

use Eloquent as Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

/**
 * Class WinnerGeneralSelected
 *
 * @package App\Models
 * @version October 27, 2021, 1:19 am WAT
 * @property string $tombola_num
 * @property string $player_name
 * @property string $telephone
 * @property string $store_name
 * @property boolean $is_winner
 * @property string $winning_prise
 * @property int $id
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @method static \Database\Factories\WinnerGeneralSelectedFactory factory(...$parameters)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected newQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected query()
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected whereIsWinner($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected wherePlayerName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected whereStoreName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected whereTelephone($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected whereTombolaNum($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected whereUpdatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerGeneralSelected whereWinningPrise($value)
 * @mixin Model
 */
class WinnerGeneralSelected extends Model
{

    use HasFactory;

    public $table = 'general_winners_selected';

    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';



    public $fillable = [
        'tombola_num',
        'player_name',
        'telephone',
        'store_name',
        'is_winner',
        'winning_prise'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'tombola_num' => 'string',
        'player_name' => 'string',
        'telephone' => 'string',
        'store_name' => 'string',
        'is_winner' => 'boolean',
        'winning_prise' => 'string'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        'created_at' => 'nullable',
        'updated_at' => 'nullable',
        'tombola_num' => 'required|string|max:255',
        'player_name' => 'required|string|max:255',
        'telephone' => 'required|string|max:255',
        'store_name' => 'required|string|max:255',
        'is_winner' => 'required|boolean',
        'winning_prise' => 'nullable|string|max:255'
    ];


}
