<?php

namespace App\Models;

use Eloquent as Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

/**
 * Class WinnerSelected
 *
 * @package App\Models
 * @version October 27, 2021, 12:25 am WAT
 * @property string $tombola_num
 * @property string $player_name
 * @property string $telephone
 * @property int $id
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @method static \Database\Factories\WinnerSelectedFactory factory(...$parameters)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected newQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected query()
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected wherePlayerName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected whereTelephone($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected whereTombolaNum($value)
 * @method static \Illuminate\Database\Eloquent\Builder|WinnerSelected whereUpdatedAt($value)
 * @mixin Model
 */
class WinnerSelected extends Model
{

    use HasFactory;

    public $table = 'winners_selected';

    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';


    public $fillable = [
        'tombola_num',
        'player_name',
        'telephone'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'tombola_num' => 'string',
        'player_name' => 'string',
        'telephone' => 'string'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        'created_at' => 'nullable',
        'updated_at' => 'nullable',
        'tombola_num' => 'required|string|max:255',
        'player_name' => 'required|string|max:255',
        'telephone' => 'required|string|max:255'
    ];


}
